diff -uNr linux-heretic-1.0/Makefile linux-heretic-1.0.new/Makefile
--- linux-heretic-1.0/Makefile	Fri Aug 20 09:34:13 1999
+++ linux-heretic-1.0.new/Makefile	Thu Oct 14 15:17:31 1999
@@ -32,15 +32,17 @@
 
 COPT.FreeBSD = -m486 -O2 -malign-jumps=2 -malign-functions=2 -D__32BIT__
 
-COPT.arm = -O2 -D__32BIT__ -fsigned-char -fomit_frame_pointer \
-           -DHAVE_ALLOCA_H
+COPT.arm = -O2 -D__32BIT__ -fsigned-char -fomit-frame-pointer \
+           -DHAVE_ALLOCA_H -D__PACKED__=__attribute__\ \(\(packed\)\)
 # _end_
 
+# Change this to change the platform
+COPT.arch = $(COPT.x86)
 
 # If you want IPX-netcode compiled, replace $(CDEFS.udp) with $(CDEFS.ipx)
 
 CFLAGS = -Wall -Wstrict-prototypes $(CDEFS.udp) \
-	 -I. -I.. -I/usr/X11R6/include $(COPT.x86) $(COPT.sound)
+	 -I. -I.. -I/usr/X11R6/include $(COPT.arch) $(COPT.sound)
 
 # Uncomment the line below if you want to use original "[" and "]" keys
 # for inventory access, instead of "k" and "l".
@@ -82,12 +85,7 @@
 	tables.o v_video.o w_wad.o z_zone.o in_lude.o \
 	info.o i_net.o i_system.o i_udp.o i_ipx.o i_main.o $(SOUND_OBJS)
 
-
-# If you want to compile Heretic for the Netwinder, 
-# change '(./parse_arm.sh others;)' to '(./parse_arm.sh arm;)'.
-
 all:	
-#	(./parse_arm.sh others;)
 	@echo "Choose one of following actions:"
 	@echo
 	@echo " make x11       - will build xheretic - runs under X11"
@@ -155,10 +153,10 @@
 	graphics/i_vga.o -o vgaheretic
 
 sndserver:
-	$(MAKE) -C sndserv $@
+	$(MAKE) -C sndserv COPT.arch="$(COPT.arch)" $@
 
 musserver:
-	$(MAKE) -C musserv $@
+	$(MAKE) -C musserv COPT.arch="$(COPT.arch)" $@
 
 %.o:	%.c
 	$(CC) $(CFLAGS) -c $< -o $@
diff -uNr linux-heretic-1.0/doomdata.h linux-heretic-1.0.new/doomdata.h
--- linux-heretic-1.0/doomdata.h	Tue Apr 13 17:02:58 1999
+++ linux-heretic-1.0.new/doomdata.h	Thu Oct 14 15:02:55 1999
@@ -44,9 +44,14 @@
 {
   short		textureoffset;
   short		rowoffset;
-  char		toptexture[8], bottomtexture[8], midtexture[8];
-  short		sector;				/* on viewer's side */
-} mapsidedef_t;
+
+  char          toptexture[8]  __PACKED__ ,
+		bottomtexture[8]  __PACKED__ ,
+		midtexture[8]  __PACKED__ ;
+  
+  short         sector  __PACKED__ ;
+    /* on viewer's side */
+}   __PACKED__ mapsidedef_t;
 
 typedef struct
 {
@@ -54,7 +59,7 @@
   short		flags;
   short		special, tag;
   short		sidenum[2];			/* sidenum[1] will be -1 if one sided */
-} maplinedef_t;
+}  __PACKED__ maplinedef_t;
 
 #define	ML_BLOCKING	        1
 #define	ML_BLOCKMONSTERS	2
@@ -79,10 +84,11 @@
 typedef	struct
 {
   short		floorheight, ceilingheight;
-  char		floorpic[8], ceilingpic[8];
-  short		lightlevel;
-  short		special, tag;
-} mapsector_t;
+
+  char          floorpic[8], ceilingpic[8]  __PACKED__ ;
+  short         lightlevel  __PACKED__ ;
+  short         special  __PACKED__ , tag  __PACKED__ ;
+}  __PACKED__  mapsector_t;
 
 typedef struct
 {
@@ -112,7 +118,7 @@
   short		x,y,dx,dy;		      /* partition line */
   short		bbox[2][4];		      /* bounding box for each child */
   unsigned short    children[2];	      /* if NF_SUBSECTOR its a subsector */
-} mapnode_t;
+}  __PACKED__  mapnode_t;
 
 typedef struct
 {
@@ -120,7 +126,7 @@
   short		angle;
   short		type;
   short		options;
-} mapthing_t;
+}  __PACKED__  mapthing_t;
 
 #define	MTF_EASY		1
 #define	MTF_NORMAL		2
@@ -142,23 +148,22 @@
   short	patch;
   short	stepdir;
   short	colormap;
-} mappatch_t;
+}  __PACKED__  mappatch_t;
 
 typedef struct
 {
   char		name[8];
-  boolean		masked;	
-  short		width;
-  short		height;
+  boolean       masked  __PACKED__ ;
+  short         width  __PACKED__ ;
+  short         height  __PACKED__ ;
 #if 1
-  int32_t	columndirectory;	// OBSOLETE
+  int32_t	columndirectory  __PACKED__ ; /* OBSOLETE */
 #else
-  void		**columndirectory;	// OBSOLETE
-#endif
-
-  short		patchcount;
-  mappatch_t	patches[1];
-} maptexture_t;
+  void          **columndirectory  __PACKED__ ;     /* OBSOLETE */
+#endif 
+  short         patchcount  __PACKED__ ;
+  mappatch_t    patches[1]  __PACKED__ ;
+}  __PACKED__  maptexture_t;
 
 
 /*
@@ -172,10 +177,10 @@
 /* posts are runs of non masked source pixels */
 typedef struct
 {
-  byte		topdelta;		/* -1 is the last post in a column */
-  byte		length;
+  byte        topdelta;      /* -1 is the last post in a column */
+  byte        length  __PACKED__ ;
   /* length data bytes follows */
-} post_t;
+}  __PACKED__  post_t;
 
 /* column_t is a list of 0 or more post_t, (byte)-1 terminated */
 typedef post_t	column_t;
@@ -192,15 +197,14 @@
   short		topoffset;			/* pixels below the origin */
   int		columnofs[8];		        /* only [width] used */
   /* the [0] is &columnofs[width] */
-} patch_t;
+}   __PACKED__  patch_t;
 
 /* a pic is an unmasked block of pixels */
 typedef struct
 {
-  byte		width,height;
-  byte		data;
-} pic_t;
-
+  byte           width,height  __PACKED__ ;
+  byte           data  __PACKED__ ;
+}  __PACKED__  pic_t;
 
 /*
   ===============================================================================
diff -uNr linux-heretic-1.0/doomdef.h linux-heretic-1.0.new/doomdef.h
--- linux-heretic-1.0/doomdef.h	Wed Apr 21 10:55:53 1999
+++ linux-heretic-1.0.new/doomdef.h	Thu Oct 14 15:02:55 1999
@@ -165,22 +165,22 @@
 typedef struct
 {
   evtype_t	type;
-  int		data1;		/* keys / mouse/joystick buttons */
-  int		data2;		/* mouse/joystick x move */
-  int		data3;		/* mouse/joystick y move */
-} event_t;
+  int		data1  __PACKED__ ;		/* keys / mouse/joystick buttons */
+  int		data2  __PACKED__ ;		/* mouse/joystick x move */
+  int		data3  __PACKED__ ;		/* mouse/joystick y move */
+}  __PACKED__  event_t;
 
 typedef struct
 {
   char		forwardmove;	/* *2048 for move */
-  char		sidemove;       /* *2048 for move */
-  short		angleturn;      /* <<16 for angle delta */
-  short		consistancy;	/* checks for net game */
-  byte		chatchar;
-  byte		buttons;
-  byte		lookfly;	/* look/fly up/down/centering */
-  byte		arti;		/* artitype_t to use */
-} ticcmd_t;
+  char		sidemove  __PACKED__ ;       /* *2048 for move */
+  short		angleturn  __PACKED__ ;      /* <<16 for angle delta */
+  short		consistancy  __PACKED__ ;	/* checks for net game */
+  byte		chatchar  __PACKED__ ;
+  byte		buttons  __PACKED__ ;
+  byte		lookfly  __PACKED__ ;	/* look/fly up/down/centering */
+  byte		arti  __PACKED__ ;		/* artitype_t to use */
+}  __PACKED__  ticcmd_t;
 
 
 /*
@@ -303,13 +303,13 @@
 typedef struct
 {
   ammotype_t ammo;
-  int upstate;
-  int downstate;
-  int readystate;
-  int atkstate;
-  int holdatkstate;
-  int flashstate;
-} weaponinfo_t;
+  int upstate  __PACKED__ ;
+  int downstate  __PACKED__ ;
+  int readystate  __PACKED__ ;
+  int atkstate  __PACKED__ ;
+  int holdatkstate  __PACKED__ ;
+  int flashstate  __PACKED__ ;
+}  __PACKED__  weaponinfo_t;
 
 extern weaponinfo_t wpnlev1info[NUMWEAPONS];
 extern weaponinfo_t wpnlev2info[NUMWEAPONS];
@@ -363,7 +363,7 @@
 {
   int type;
   int count;
-} inventory_t;
+}  __PACKED__  inventory_t;
 
 
 /*
@@ -396,13 +396,13 @@
 typedef struct
 {  
   spritenum_t	        sprite;
-  long			frame;
-  long			tics;
+  long			frame  __PACKED__ ;
+  long			tics  __PACKED__ ;
   
-  actionf_t		action;
-  statenum_t		nextstate;
-  long			misc1, misc2;
-} state_t;
+  actionf_t		action  __PACKED__ ;
+  statenum_t		nextstate  __PACKED__ ;
+  long			misc1  __PACKED__ , misc2  __PACKED__ ;
+}  __PACKED__  state_t;
 
 extern state_t	states[NUMSTATES];
 extern char *sprnames[NUMSPRITES];
@@ -413,9 +413,9 @@
 
 typedef struct thinker_s
 {
-  struct		thinker_s	*prev, *next;
-  think_t		function;
-} thinker_t;
+  struct		thinker_s	*prev, *next  __PACKED__ ;
+  think_t		function  __PACKED__ ;
+}  __PACKED__  thinker_t;
 
 struct player_s;
 
@@ -424,52 +424,52 @@
   thinker_t		thinker;       /* thinker links */
   
   /* info for drawing */
-  fixed_t		x,y,z;
-  struct mobj_s	*snext, *sprev;	       /* links in sector (if needed) */
-  angle_t		angle;
-  spritenum_t		sprite;	       /* used to find patch_t and flip value */
-  int			frame;	       /*  might be ord with FF_FULLBRIGHT */
+  fixed_t		x  __PACKED__ ,y  __PACKED__ ,z  __PACKED__ ;
+  struct mobj_s	*snext  __PACKED__ , *sprev  __PACKED__ ;	       /* links in sector (if needed) */
+  angle_t		angle  __PACKED__ ;
+  spritenum_t		sprite  __PACKED__ ;	       /* used to find patch_t and flip value */
+  int			frame  __PACKED__ ;	       /*  might be ord with FF_FULLBRIGHT */
 
   /* interaction info */
-  struct mobj_s	*bnext, *bprev;		/* links in blocks (if needed) */
-  struct subsector_s	*subsector;
-  fixed_t		floorz, ceilingz; /* closest together of contacted secs */
-  fixed_t		radius, height;	  /* for movement checking */
-  fixed_t		momx, momy, momz; /* momentums */
-  
-  int		        validcount;	  /* if == validcount, already checked */
-  
-  mobjtype_t		type;
-  mobjinfo_t		*info;		  /* &mobjinfo[mobj->type] */
-  int			tics;		  /* state tic counter */
-  state_t		*state;
-  int			damage;		  /* For missiles */
-  int			flags;
-  int			flags2;		  /* Heretic flags */
-  long			special1;	  /* Special info */
-  long			special2;	  /* Special info */
-  int		        health;
-  int			movedir;	  /* 0-7 */
-  int		        movecount;	  /* when 0, select a new dir */
-  struct mobj_s *target;		  /* thing being chased/attacked (or NULL) */
+  struct mobj_s	*bnext  __PACKED__ , *bprev  __PACKED__ ;		/* links in blocks (if needed) */
+  struct subsector_s	*subsector  __PACKED__ ;
+  fixed_t		floorz  __PACKED__ , ceilingz  __PACKED__ ; /* closest together of contacted secs */
+  fixed_t		radius  __PACKED__ , height  __PACKED__ ;	  /* for movement checking */
+  fixed_t		momx  __PACKED__ , momy  __PACKED__ , momz  __PACKED__ ; /* momentums */
+  
+  int		        validcount  __PACKED__ ;	  /* if == validcount, already checked */
+  
+  mobjtype_t		type  __PACKED__ ;
+  mobjinfo_t		*info  __PACKED__ ;		  /* &mobjinfo[mobj->type] */
+  int			tics  __PACKED__ ;		  /* state tic counter */
+  state_t		*state  __PACKED__ ;
+  int			damage  __PACKED__ ;		  /* For missiles */
+  int			flags  __PACKED__ ;
+  int			flags2  __PACKED__ ;		  /* Heretic flags */
+  int			special1  __PACKED__ ;	  /* Special info */
+  int			special2  __PACKED__ ;	  /* Special info */
+  int		        health  __PACKED__ ;
+  int			movedir  __PACKED__ ;	  /* 0-7 */
+  int		        movecount  __PACKED__ ;	  /* when 0, select a new dir */
+  struct mobj_s *target  __PACKED__ ;		  /* thing being chased/attacked (or NULL) */
   /* also the originator for missiles */
-  int			reactiontime;	  /* if non 0, don't attack yet */
+  int			reactiontime  __PACKED__ ;	  /* if non 0, don't attack yet */
   /* used by player to freeze a bit after */
   /* teleporting */
-  int			threshold;	  /* if >0, the target will be chased */
+  int			threshold  __PACKED__ ;	  /* if >0, the target will be chased */
   /* no matter what (even if shot) */
-  struct player_s	*player;	  /* only valid if type == MT_PLAYER */
-  int			lastlook;	  /* player number last looked for */
+  struct player_s	*player  __PACKED__ ;	  /* only valid if type == MT_PLAYER */
+  int			lastlook  __PACKED__ ;	  /* player number last looked for */
   
-  mapthing_t		spawnpoint;	  /* for nightmare respawn */
-} mobj_t;
+  mapthing_t		spawnpoint  __PACKED__ ;	  /* for nightmare respawn */
+}  __PACKED__  mobj_t;
 
 /* each sector has a degenmobj_t in it's center for sound origin purposes */
 typedef struct
 {
   thinker_t		thinker;	  /* not used for anything */
-  fixed_t		x,y,z;
-} degenmobj_t;
+  fixed_t		x  __PACKED__  ,y  __PACKED__ ,z  __PACKED__ ;
+}  __PACKED__  degenmobj_t;
 
 /* Most damage defined using HITDICE */
 #define HITDICE(a) ((1+(P_Random()&7))*a)
@@ -574,10 +574,9 @@
 typedef struct
 {
   state_t	*state;		/* a NULL state means not active */
-  int		tics;
-  fixed_t	sx, sy;
-} pspdef_t;
-
+  int		tics  __PACKED__ ;
+  fixed_t	sx  __PACKED__ , sy  __PACKED__ ;
+}  __PACKED__  pspdef_t;
 
 
 /*
@@ -591,57 +590,57 @@
 typedef struct player_s
 {
   mobj_t *mo;
-  playerstate_t playerstate;
-  ticcmd_t cmd;
+  playerstate_t playerstate  __PACKED__ ;
+  ticcmd_t cmd  __PACKED__ ;
   
-  fixed_t		viewz;		   /* focal origin above r.z */
-  fixed_t		viewheight;	   /* base height above floor for viewz */
-  fixed_t		deltaviewheight;   /* squat speed */
-  fixed_t		bob;		   /* bounded/scaled total momentum */
-
-  int			flyheight;
-  int			lookdir;
-  boolean		centering;
-  int			health;		   /* only used between levels, mo->health */
+  fixed_t		viewz  __PACKED__ ;		   /* focal origin above r.z */
+  fixed_t		viewheight  __PACKED__ ;	   /* base height above floor for viewz */
+  fixed_t		deltaviewheight  __PACKED__ ;   /* squat speed */
+  fixed_t		bob  __PACKED__ ;		   /* bounded/scaled total momentum */
+
+  int			flyheight  __PACKED__ ;
+  int			lookdir  __PACKED__ ;
+  boolean		centering  __PACKED__ ;
+  int			health  __PACKED__ ;		   /* only used between levels, mo->health */
   /* is used during levels */
-  int			armorpoints, armortype;	/* armor type is 0-2 */
+  int			armorpoints  __PACKED__ , armortype  __PACKED__ ;	/* armor type is 0-2 */
   
-  inventory_t	        inventory[NUMINVENTORYSLOTS];
-  artitype_t	        readyArtifact;
-  int			artifactCount;
-  int 		        inventorySlotNum;
-  int			powers[NUMPOWERS];
-  boolean		keys[NUMKEYS];
-  boolean		backpack;
-  signed int		frags[MAXPLAYERS];	  /* kills of other players */
-  weapontype_t	        readyweapon;
-  weapontype_t	        pendingweapon;		  /* wp_nochange if not changing */
-  boolean		weaponowned[NUMWEAPONS];
-  int			ammo[NUMAMMO];
-  int			maxammo[NUMAMMO];
-  int			attackdown, usedown;	  /* true if button down last tic */
-  int			cheats;			  /* bit flags */
-  
-  int			refire;			  /* refired shots are less accurate */
-  
-  int			killcount, 
-                        itemcount, 
-                        secretcount;              /* for intermission */
-  char		        *message;		  /* hint messages */
-  int			messageTics;		  /* counter for showing messages */
-  int			damagecount, bonuscount;  /* for screen flashing */
-  int			flamecount;		  /* for flame thrower duration */
-  mobj_t		*attacker;		  /* who did damage (NULL for floors) */
-  int			extralight;		  /* so gun flashes light up areas */
-  int			fixedcolormap;		  /* can be set to REDCOLORMAP, etc */
-  int			colormap;		  /* 0-3 for which color to draw player */
-  pspdef_t	        psprites[NUMPSPRITES];	  /* view sprites (gun, etc) */
-  boolean		didsecret;		  /* true if secret level has been done */
-  int			chickenTics;		  /* player is a chicken if > 0 */
-  int			chickenPeck;		  /* chicken peck countdown */
-  mobj_t		*rain1;			  /* active rain maker 1 */
-  mobj_t		*rain2;			  /* active rain maker 2 */
-} player_t;
+  inventory_t	        inventory[NUMINVENTORYSLOTS]  __PACKED__ ;
+  artitype_t	        readyArtifact  __PACKED__ ;
+  int			artifactCount  __PACKED__ ;
+  int 		        inventorySlotNum  __PACKED__ ;
+  int			powers[NUMPOWERS]  __PACKED__ ;
+  boolean		keys[NUMKEYS]  __PACKED__ ;
+  boolean		backpack  __PACKED__ ;
+  signed int		frags[MAXPLAYERS]  __PACKED__ ;	  /* kills of other players */
+  weapontype_t	        readyweapon  __PACKED__ ;
+  weapontype_t	        pendingweapon  __PACKED__ ;		  /* wp_nochange if not changing */
+  boolean		weaponowned[NUMWEAPONS]  __PACKED__ ;
+  int			ammo[NUMAMMO]  __PACKED__ ;
+  int			maxammo[NUMAMMO]  __PACKED__ ;
+  int			attackdown  __PACKED__ , usedown  __PACKED__ ;	  /* true if button down last tic */
+  int			cheats  __PACKED__ ;			  /* bit flags */
+  
+  int			refire  __PACKED__ ;			  /* refired shots are less accurate */
+  
+  int			killcount  __PACKED__ , 
+                        itemcount  __PACKED__ , 
+                        secretcount  __PACKED__ ;              /* for intermission */
+  char		        *message  __PACKED__ ;		  /* hint messages */
+  int			messageTics  __PACKED__ ;		  /* counter for showing messages */
+  int			damagecount  __PACKED__ , bonuscount  __PACKED__ ;  /* for screen flashing */
+  int			flamecount  __PACKED__ ;		  /* for flame thrower duration */
+  mobj_t		*attacker  __PACKED__ ;		  /* who did damage (NULL for floors) */
+  int			extralight  __PACKED__ ;		  /* so gun flashes light up areas */
+  int			fixedcolormap  __PACKED__ ;		  /* can be set to REDCOLORMAP, etc */
+  int			colormap  __PACKED__ ;		  /* 0-3 for which color to draw player */
+  pspdef_t	        psprites[NUMPSPRITES]  __PACKED__ ;	  /* view sprites (gun, etc) */
+  boolean		didsecret  __PACKED__ ;		  /* true if secret level has been done */
+  int			chickenTics  __PACKED__ ;		  /* player is a chicken if > 0 */
+  int			chickenPeck  __PACKED__ ;		  /* chicken peck countdown */
+  mobj_t		*rain1  __PACKED__ ;			  /* active rain maker 1 */
+  mobj_t		*rain2  __PACKED__ ;			  /* active rain maker 2 */
+}  __PACKED__  player_t;
 
 #define CF_NOCLIP		1
 #define	CF_GODMODE		2
@@ -652,41 +651,41 @@
 typedef struct
 {
   unsigned	checksum;	     /* high bit is retransmit request */
-  byte		retransmitfrom;	     /* only valid if NCMD_RETRANSMIT */
-  byte		starttic;
-  byte		player, numtics;
-  ticcmd_t	cmds[BACKUPTICS];
-} doomdata_t;
+  byte		retransmitfrom  __PACKED__ ;	     /* only valid if NCMD_RETRANSMIT */
+  byte		starttic  __PACKED__ ;
+  byte		player  __PACKED__ , numtics  __PACKED__ ;
+  ticcmd_t	cmds[BACKUPTICS]  __PACKED__ ;
+}  __PACKED__  doomdata_t;
 
 typedef struct
 {
   long	id;
-  short	intnum;			     /* DOOM executes an int to execute commands */
+  short	intnum  __PACKED__ ;			     /* DOOM executes an int to execute commands */
   
   /* communication between DOOM and the driver */
-  short	command;		     /* CMD_SEND or CMD_GET */
-  short	remotenode;		     /* dest for send, set by get (-1 = no packet) */
-  short	datalength;		     /* bytes in doomdata to be sent */
+  short	command  __PACKED__ ;		     /* CMD_SEND or CMD_GET */
+  short	remotenode  __PACKED__ ;		     /* dest for send, set by get (-1 = no packet) */
+  short	datalength  __PACKED__ ;		     /* bytes in doomdata to be sent */
 
   /* info common to all nodes */
-  short	numnodes;		     /* console is allways node 0 */
-  short	ticdup;			     /* 1 = no duplication, 2-5 = dup for slow nets */
-  short	extratics;		     /* 1 = send a backup tic in every packet */
-  short	deathmatch;		     /* 1 = deathmatch */
-  short	savegame;		     /* -1 = new game, 0-5 = load savegame */
-  short	episode;		     /* 1-3 */
-  short	map;			     /* 1-9 */
-  short	skill;			     /* 1-5 */
+  short	numnodes  __PACKED__ ;		     /* console is allways node 0 */
+  short	ticdup  __PACKED__ ;			     /* 1 = no duplication, 2-5 = dup for slow nets */
+  short	extratics  __PACKED__ ;		     /* 1 = send a backup tic in every packet */
+  short	deathmatch  __PACKED__ ;		     /* 1 = deathmatch */
+  short	savegame  __PACKED__ ;		     /* -1 = new game, 0-5 = load savegame */
+  short	episode  __PACKED__ ;		     /* 1-3 */
+  short	map  __PACKED__ ;			     /* 1-9 */
+  short	skill  __PACKED__ ;			     /* 1-5 */
   
   /* info specific to this node */
-  short	consoleplayer;
-  short	numplayers;
-  short	angleoffset;	             /* 1 = left, 0 = center, -1 = right */
-  short	drone;			     /* 1 = drone */
+  short	consoleplayer  __PACKED__ ;
+  short	numplayers  __PACKED__ ;
+  short	angleoffset  __PACKED__ ;	             /* 1 = left, 0 = center, -1 = right */
+  short	drone  __PACKED__ ;			     /* 1 = drone */
   
   /* packet data to be sent */
-  doomdata_t	data;
-} doomcom_t;
+  doomdata_t	data  __PACKED__ ;
+}  __PACKED__  doomcom_t;
 
 #define	DOOMCOM_ID	0x12345678l
 
@@ -887,11 +886,11 @@
 typedef struct memblock_s
 {
   size_t                  size;         /* including the header and possibly tiny fragments */
-  void                    **user;       /* NULL if a free block */
-  int                     tag;          /* purgelevel */
-  int                     id;           /* should be ZONEID */
-  struct memblock_s       *next, *prev;
-} memblock_t;
+  void                    **user  __PACKED__ ;       /* NULL if a free block */
+  int                     tag  __PACKED__ ;          /* purgelevel */
+  int                     id  __PACKED__ ;           /* should be ZONEID */
+  struct memblock_s       *next  __PACKED__ , *prev  __PACKED__ ;
+}  __PACKED__  memblock_t;
 
 #define Z_ChangeTag(p,t) \
 { \
@@ -908,8 +907,8 @@
 typedef struct
 {
   char		name[8];
-  int		handle,position,size;
-} lumpinfo_t;
+  int		handle  __PACKED__ ,position  __PACKED__ ,size  __PACKED__ ;
+}  __PACKED__  lumpinfo_t;
 
 extern lumpinfo_t *lumpinfo;
 extern	int	numlumps;
diff -uNr linux-heretic-1.0/i_ipx.c linux-heretic-1.0.new/i_ipx.c
--- linux-heretic-1.0/i_ipx.c	Mon Mar 15 11:51:31 1999
+++ linux-heretic-1.0.new/i_ipx.c	Thu Oct 14 15:02:44 1999
@@ -38,10 +38,10 @@
 /* setupdata_t is used as doomdata_t during setup (from ipxnet.h/ipxsrc.zip) */
 typedef struct
 {
-  short gameid; /* so multiple games can setup at once */
-  short drone;
-  short nodesfound;
-  short nodeswanted;
+  short gameid __attribute__((packed)); /* so multiple games can setup at once */
+  short drone __attribute__((packed));
+  short nodesfound __attribute__((packed));
+  short nodeswanted __attribute__((packed));
 } setupdata_t;
 
 typedef unsigned char ipx_node[6];
diff -uNr linux-heretic-1.0/musserv/Makefile linux-heretic-1.0.new/musserv/Makefile
--- linux-heretic-1.0/musserv/Makefile	Mon Mar 22 17:21:11 1999
+++ linux-heretic-1.0.new/musserv/Makefile	Thu Oct 14 15:15:09 1999
@@ -11,7 +11,7 @@
 
 #CFLAGS = $(WFLAGS) -O2 -mpentiumpro
 #CFLAGS = -Wall -g3
-CFLAGS = $(WFLAGS) -O2
+CFLAGS = $(WFLAGS) $(COPT.arch)
 AFLAGS = $(CFLAGS)
 LDFLAGS = # -s
 LIBS   = 
diff -uNr linux-heretic-1.0/musserv/musserver.h linux-heretic-1.0.new/musserv/musserver.h
--- linux-heretic-1.0/musserv/musserver.h	Sat Mar 20 21:17:12 1999
+++ linux-heretic-1.0.new/musserv/musserver.h	Thu Oct 14 15:03:08 1999
@@ -35,6 +35,10 @@
 #  include <awe_voice.h>
 #endif
 
+#ifndef __PACKED__
+#define __PACKED__
+#endif
+
 extern char *progname;
 extern int verbose;
 extern int unknevents;
@@ -85,7 +89,7 @@
   unsigned char level_2;        /* OP 2: output level */
   unsigned char unused;
   short         basenote;       /* base note offset */
-} __attribute__ ((packed));
+}  __PACKED__ ;
 
 
 struct opl_instr {
@@ -97,7 +101,7 @@
 	unsigned char         finetune;
 	unsigned char         note;
 	struct OPL2instrument patchdata[2];
-} __attribute__ ((packed));
+}  __PACKED__ ;
 
 
 typedef struct OPLfile {
@@ -115,7 +119,7 @@
 	unsigned short sec_channels;   // count of secondary channels
 	unsigned short instrCnt;
 	unsigned short dummy;
-} __attribute__ ((packed));
+}  __PACKED__ ;
 
 
 typedef struct MUSfile {
diff -uNr linux-heretic-1.0/sndserv/Makefile linux-heretic-1.0.new/sndserv/Makefile
--- linux-heretic-1.0/sndserv/Makefile	Mon Mar 15 10:31:41 1999
+++ linux-heretic-1.0.new/sndserv/Makefile	Thu Oct 14 15:17:46 1999
@@ -1,12 +1,6 @@
 CC = gcc
 
-COPT.x86 = -m486 -O2 -malign-jumps=2 -malign-functions=2
-COPT.m68k = -m68020-60 -O2 -fomit-frame-pointer -D__BIG_ENDIAN__
-COPT.arm = -O2 -fomit-frame-pointer -fpack-struct -fsigned-char
-
-# For arm, replace $(COPT.x86) with $(COPT.arm)
-
-CFLAGS=	-Wall -Wstrict-prototypes $(COPT.x86)
+CFLAGS=	-Wall -Wstrict-prototypes $(COPT.arch)
 
 LIBS=	-lm
 
diff -uNr linux-heretic-1.0/w_wad.c linux-heretic-1.0.new/w_wad.c
--- linux-heretic-1.0/w_wad.c	Tue Apr 13 17:02:58 1999
+++ linux-heretic-1.0.new/w_wad.c	Thu Oct 14 15:02:37 1999
@@ -56,9 +56,9 @@
 typedef struct
 {
   char		identification[4];	/* should be IWAD */
-  int		numlumps;
-  int		infotableofs;
-} wadinfo_t;
+  int		numlumps  __PACKED__ ;
+  int		infotableofs  __PACKED__ ;
+}  __PACKED__  wadinfo_t;
 
 
 typedef struct
@@ -66,7 +66,7 @@
   int		filepos;
   int		size;
   char		name[8];
-} filelump_t;
+}  __PACKED__  filelump_t;
 
 
 /* =============
@@ -144,7 +144,7 @@
 
 int wadopen(const char* fileName)
 {
-    int fd;
+    int fd = -1;
     char* fn;
     char* envhome;
     
@@ -158,16 +158,17 @@
 	    free(fn);
 	    return fd;
 	}
-    else if ((envhome = getenv("HERETICHOME")) != NULL)
+    
+    if ((envhome = getenv("HERETICHOME")) != NULL)
 	{
 	    fn = (char*) malloc(strlen(envhome)+strlen("/")+strlen(fileName)+1);
 	    assert(fn);
 	    sprintf(fn, "%s/%s", envhome, fileName);
 	    fd = open(fn, O_RDONLY | O_BINARY);
 	    free(fn);
-	    return fd;	    
 	}
-    else if ((envhome = getenv("HOME")) != NULL)
+
+    if ((fd < 0) && ((envhome = getenv("HOME")) != NULL))
 	{
 	    fn = (char*) malloc(strlen(envhome)+strlen(HOMEDIR"/")
 				+strlen(fileName)+1);
@@ -175,13 +176,38 @@
 	    sprintf(fn, "%s"HOMEDIR"/%s", envhome, fileName);
 	    fd = open(fn, O_RDONLY | O_BINARY);
 	    free(fn);
-	    return fd;	    	    
 	}
-    else   	  
-	if ((fd = open(fileName, O_RDONLY | O_BINARY)) >= 0)
-	    return fd;
 
-    return -1;
+    if ((fd < 0) && (envhome = getenv("PATH")))
+        {
+            char *path = strdup(envhome), *curentry;
+            assert(path);
+            while (strlen(path) && (fd < 0))
+                {
+                    if (!(curentry = strrchr(path, ':')))
+                        curentry = path;
+                    else
+                        *curentry++ = 0;
+                    fn = (char*) malloc(strlen(curentry)+19+strlen(fileName));  /* Add space for /, ../share/heretic/ */
+                    assert(fn);
+                    sprintf(fn, "%s/%s", curentry, fileName);
+                    fd = open(fn, O_RDONLY | O_BINARY);      
+                    /* check ../share/heretic */
+                    if (fd < 0)                 
+                        {      
+                            sprintf(fn, "%s/../share/heretic/%s", curentry, fileName);
+                            fd = open(fn, O_RDONLY | O_BINARY);
+                        }
+                    free(fn);
+                    *curentry = 0;                          
+                }
+            free(path);
+        }      
+
+    if (fd < 0)
+        fd = open(fileName, O_RDONLY | O_BINARY);
+
+    return fd;
 }
 
 
diff -uNr linux-heretic-1.0/d_main.c linux-heretic-1.0.new/d_main.c
--- linux-heretic-1.0/d_main.c	Fri Aug 20 09:20:46 1999
+++ linux-heretic-1.0.new/d_main.c	Fri Oct 15 14:34:54 1999
@@ -618,6 +618,16 @@
   
   /* fprintf(stdout, "basedefault: %s\n", basedefault ); */
   
+  /* Add current directory to path */
+  if (getenv("PATH"))
+  {
+  	char *path = getenv("PATH");
+  	char *newpath = malloc(strlen(path)+2);
+  	sprintf(newpath, "%s:", path);
+  	setenv("PATH", newpath, 1);
+  	free(newpath);
+  }
+  
   /* Check if filtering is wanted */ 
   if ( M_CheckParm("-linear")!=0 ) lifilter=1;
   if ( M_CheckParm("-bilinear")!=0 ) bilifilter=1;
diff -uNr linux-heretic-1.0/m_misc.c linux-heretic-1.0.new/m_misc.c
--- linux-heretic-1.0/m_misc.c	Wed Apr 21 10:55:54 1999
+++ linux-heretic-1.0.new/m_misc.c	Fri Oct 15 14:50:07 1999
@@ -466,14 +466,14 @@
   { "key_useartifact", &key_useartifact, KEY_ENTER },
 
 #ifdef SNDSERV
-  {"sndserver", (long *) &sndserver_filename, (long) "./sndserver"},
+  {"sndserver", (long *) &sndserver_filename, (long) "sndserver"},
   {"sndopts", (long *) &sndserver_options, (long) "-quiet"},
 #endif
 #ifdef __DOSOUND__
   {"mb_used", &mb_used, 2},
 #endif
 #ifdef MUSSERV
-  {"musserver", (long *) &musserver_filename, (long) "./musserver"},
+  {"musserver", (long *) &musserver_filename, (long) "musserver"},
   {"musopts", (long *) &musserver_options, (long) ""},
 #endif
 #endif
diff -uNr linux-heretic-1.0/sndserv/wadread.c linux-heretic-1.0.new/sndserv/wadread.c
--- linux-heretic-1.0/sndserv/wadread.c	Thu Feb 11 18:29:12 1999
+++ linux-heretic-1.0.new/sndserv/wadread.c	Fri Oct 15 15:18:11 1999
@@ -156,7 +156,7 @@
 	    else
 		free(fn);
 	}
-    else if ((envhome = getenv("HOME")) != NULL)
+    if ((envhome = getenv("HOME")) != NULL)
 	{
 	    fn = (char*) malloc(strlen(envhome)+strlen(HOMEDIR"/")
 				+strlen(wadname)+1);
@@ -167,8 +167,37 @@
 	    else
 		free(fn);
 	}
-    else
-	if (!access(wadname, R_OK))
+    if ((envhome = getenv("PATH")))
+        {
+            char *path = strdup(envhome), *curentry;
+            assert(path);                           
+            while (strlen(path))
+                {
+                    if (!(curentry = strrchr(path, ':')))
+                        curentry = path;
+                    else
+                        *curentry++ = 0;
+                    fn = (char*)malloc(strlen(curentry)+19+strlen(wadname));   /* Add space for /, ../share/heretic/ */
+                    assert(fn);                                 
+                    sprintf(fn, "%s/%s", curentry, wadname);
+                    if (!access(fn, R_OK))
+                        {
+                            free(path);
+                            return fn;
+                        }
+                    /* check ../share/heretic */
+                    sprintf(fn, "%s/../share/heretic/%s", curentry, wadname);
+                    if (!access(fn, R_OK))
+                        {
+                            free(path);
+                            return fn;
+                        }
+                    free(fn);
+                    *curentry = 0;                          
+                }
+            free(path);
+        }        
+    if (!access(wadname, R_OK))
 	    return wadname;
     
     fn = (char*) malloc(strlen("./")+strlen(wadname)+1);
diff -uNr linux-heretic-1.0/soundclient/i_sound.c linux-heretic-1.0.new/soundclient/i_sound.c
--- linux-heretic-1.0/soundclient/i_sound.c	Mon Mar 22 20:22:32 1999
+++ linux-heretic-1.0.new/soundclient/i_sound.c	Fri Oct 15 15:38:14 1999
@@ -377,9 +377,12 @@
 void I_InitSound(void)
 {
 #ifdef SNDSERV
-  char buffer[256];
-  
+  char *buffer = (char *)malloc(256);
+  if (!buffer)
+  	return;
+ 
   sprintf(buffer, "%s", sndserver_filename);
+  find_in_path(&buffer, 256);
   
   /* start sound process */
   if ( !access(buffer, X_OK) )
@@ -393,6 +396,8 @@
     }
   else
     fprintf(stderr, "Could not start sound server [%s]\n", buffer);
+  
+  free(buffer);
 #endif /* SNDSERV */
 }
 
@@ -425,10 +430,14 @@
 void I_InitMusic(void)
 {
 #ifdef MUSSERV
-  char buffer[256];
+  char *buffer = (char *)malloc(256);
   int old_uid=-1;
   
+  if (!buffer)
+  	return;
+  
   sprintf(buffer, "%s", musserver_filename);
+  find_in_path(&buffer, 256);
   
   if (!access(buffer,X_OK)) {
     /* start musserver via popen() (ugly) */
@@ -444,6 +453,7 @@
     
     if (!musserver) {
       fprintf(stderr,"Could not start music server [%s]: %s\n",buffer,strerror(errno));
+      free(buffer);
       return;
     }
 
@@ -461,6 +471,8 @@
   else {
     fprintf(stderr,"Could not start music server [%s]\n",buffer);
   }
+  
+  free(buffer);
 #endif /* MUSSERV */
 }
 
@@ -563,3 +564,39 @@
 {
   return (handle == playing_handle);
 }
+
+void find_in_path(char **filename, int size)
+{
+    char *envhome = getenv("PATH"), *path, *curentry, *fn;
+    
+    if (strchr(*filename, '/') || !envhome)
+        return;
+        
+    if (!(path = strdup(envhome)))
+        return;
+    
+    while (strlen(path))
+        {
+            if (!(curentry = strrchr(path, ':')))
+                curentry = path;
+            else
+                *curentry++ = 0;
+            if (!(fn = (char*)malloc(strlen(curentry)+2+strlen(*filename))))
+                {
+                    free(path);
+                    return;
+                }
+            sprintf(fn, "%s/%s", curentry, *filename);
+            if (!access(fn, X_OK))
+                {
+                    strncpy(*filename, fn, size-1);
+                    free(fn);
+                    free(path);
+                    return;
+                }
+            free(fn);                                
+            *curentry = 0;
+        }
+   free(path);
+}      
+
